/*
	flounder - copyright 2002 Edward J. Vigmond

	This file is part of flounder.     
	
	flounder is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.     
	
	flounder is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.     
	You should have received a copy of the GNU General Public License
    along with flounder; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "../config.h"
#include "flguppy.h"

const int auxwinsizex = 300;
const int auxwinsizey = 200;

GLView :: ~GLView()
{
	timewin->window->~Fl_Double_Window();	
	horizon->window->~Fl_Double_Window();	
	vertical->window->~Fl_Double_Window();	
	model->~Glarea();
	window->~Fl_Double_Window();
}

void GLView :: arrange_aux_windows()
{
	int width = window->w();
	int height = window->h();
	int x0 = window->x();
	int y0 = window->y();

	horizon->window->resize(x0, y0+height, width, auxwinsizey );
	if( x0 < Fl::w()-x0-width ) {
		vertical->window->resize(x0+width, y0, auxwinsizex, height );
		timewin->window->resize(x0+width, y0+height, auxwinsizex, auxwinsizey );
	} else {
		vertical->window->resize(x0-auxwinsizex, y0, auxwinsizex, height );
		timewin->window->resize(x0-auxwinsizex, y0+height, auxwinsizex, auxwinsizey );
	}
	window->show();
	if( vertical->window->visible() ) vertical->window->show();
}
	
