/*
	flounder - copyright 2002 Edward J. Vigmond

	This file is part of flounder.     
	
	flounder is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.     
	
	flounder is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.     
	You should have received a copy of the GNU General Public License
    along with flounder; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//
// "$Id: arc.cxx,v 1.4.2.2 2000/06/05 21:21:15 mike Exp $"
//
// Arc drawing test program for the Fast Light Tool Kit (FLTK).
//
// Copyright 1998-2000 by Bill Spitzak and others.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//
// Please report all bugs and problems to "fltk-bugs@fltk.org".
//

#include<stdio.h>
#ifndef GRAPH_H
#define GRAPH_H
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/fl_draw.H>

const int max_num_sets=10;
const int num_labels=7;
const float nlm1= float(num_labels-1);

class Graph : public Fl_Widget {
  void draw();
  int handle(int);
public:
  Graph(int X,int Y,int W,int H) : Fl_Widget(X,Y,W,H) {numset=0;}
  int set_2d_data(const double *, const double *, int n );
  int add_2d_data(const double *, const double *, int n );
  void command( char *s ){}
  char *command(void){return ""; }
  void reset_view( void );
  void range( double &, double &, double &, double& );
  void set_range( double, double, double, double );
private:
 	const double *xv[max_num_sets], *yv[max_num_sets];
	double x0, x1, y0, y1;					// data range being plotted
	double xmin, xmax, ymin, ymax;			// data extrmea
	int np[max_num_sets];					// #points/set
	int numset;							
	char xlabel[num_labels][25], ylabel[num_labels][25]; 
	void change_view( int, int, int, int );
	void make_labels(void);
};

#endif
