/*
	flounder - copyright 2002 Edward J. Vigmond

	This file is part of flounder.     
	
	flounder is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.     
	
	flounder is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.     
	You should have received a copy of the GNU General Public License
    along with flounder; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../config.h"
#include "flguppy.h"

void HelpWin :: usage()
{
	mode = 0;

	string usagetxt[] = {
		"",
		"@m@b@C1@cflounder - a bigger struggling version of guppy",
		"",
		"@cA program to display regularly spaced 4D data",
		"",
		"command line: flounder [file1 [file2 [ ...]]]",
		"",
		"@b@B4@C7Control widget",
		"@b@B2File menu",
		"New File...\tread new file",
		"Reread\t\treread file because t dimension has changed",
		"New view\topen new window sharing data of active window",
		"@b@B2Image menu",
		"Pop\t\tbring view to top",
		"Iconify\t\ticonify view and all of its aux. windows",
		"Swap bytes\tswitch high/low order of bytes",
		"Subsample\treduce spatial image resolution by downsampling",
		"@b@B5Save as submenu\t\tsave current view as an image",
		"\tEPS\t\tbest format for 2D views, bad for 3D",
		"\tPNG\t\tbest 3D format, good for 2D",
		"\tGIF image\tuncompressed GIF",
		"\tGIF movie\tanimate once and record as an animated GIF",
		"\tAVI movie\tanimate once and record as AVI",
		"Close\t\tclose window",
		"@b@B2Options menu",
		"White bgd\tuse white for background and contour lines (when data shown)",
		"Show time\ttime display in lower left corner",
		"Gouraud shading\tgradual colour change between pixels",
		"@b@B2Help menu",
		"Usage\t\tthis message",
		"Image\t\timage header information",
		"",
		"@b@B2time slider",
		"L/R arrows\tchange time by 1",
		"Sh-L/R arrows\tlarger change in time",
		"Mouse Button 1\tchange time by 1",
		"Mouse Button 2\ttime follows mouse position",
		"Mouse Button 3\tchange time by 10",
		"",
		"Active\t\twindow to which controls settings apply",
		"@iN.B. active window is marked with ** in title bar",
		"",
		"@b@B2Animate",
		"<<\t\tstart animation in reverse",
		"||\t\tstop",
		">>\t\tstart animation forward",
		"Increment\tcount by this many frames",
		"@iModes",
		"\tonce\t\tonly show until end",
		"\tcontinuous\tloop forever",
		"\tpendulum\tforward then backward ...",
		"",
		"@b@B2Colour Scale",
		"auto\tcalibrate colour scale for each frame",
		"optimal\tcalibrate best colour scale for current frame",
		"min\tdata values below this are mapped to bottom of scale",
		"max\tdata values above this are mapped to top of scale",
		"levels\tnumber of colours in colour map",
		"",
		"@B2@b2D",
		"Dimension\twhich 2 dimensions are displayed",
		"Depth slider\tvalue of 3rd dimension at which 2D slice is taken",
		"@iAuxiliary windows",
		"\tHorizontal\thorizontal profile through cursor",
		"\tVertical\tvertical profile through cursor",
		"\tTime\t\ttime series of point under cursor",
		"\tArrange aux.\tlayout auxilliary windows nicely",
		"Cursor\t\tturn cursor on/off",
		"lines\t\tdraw grid lines through cursor",
		"value\t\tdisplay value under cursor",
		"coordinates\tdisplay coordinates of cursor",
		"Colour bar\tcontrol display of colour scale",
		"Tableau\t\tgenerate tableau of time series",
		"",
		"@B2@bContours",
		"@C2@bdisplay contours in 2D mode",
		"Contour\t\ttoggle contour display mode",
		"Show data\tshow contours lines on top of data",
		"Number\t\tnumber of contours",
		"start\t\tvalue of first contour",
		"increment\tvalue difference between contour lines",
		"@iN.B. line colours are determined by colour scale if data not shown,",
		"@i     otherwise they are determined by the background colour",
		"",
		"@B2@b3D",
		"Rotation\tcontrol rotation of data view",
		"Bounding box\tcontrol how much of block is displayed",
		"Z scale\t\tcontrol scaling in z dimension",
		"",
		"@B2@bIsosurf",
		"@b@C2Allow display of up to 2 isosurfaces in 3D mode",
		"Isosurface\ttoggle display of surface",
		"Isovalue\tvalue of isosurface",
		"red,green,blue\tcolour components of surface",
		"alpha\t\tdial to control opacity",
		"colour\t\tvisually choose colour",
		"",
		"@B2@bSolid 3D",
		"@b@C2Display 3D as a solid",
		"Solid Object Modelling\tturn 3D mode on/off",
		"Louisiana method\tlower quality and slower rendering by drawing as points",
		"transparent minimum\tdo not draw pixels with this value",
		"use transparent range\tif set, ignore pixel if min <= pixel <= max",
		"transparent maximum\tmaximum pixel value to ignore",
		"Invert range\ttake complement of transparency range",
		"",
		"@b@B4@C7Tableau popup",
		"@C4display time series of several locations in table format",
		"start\t\tstarting pixel",
		"end\t\tending pixel",
		"stride\t\tsampling period",
		"Num x/y\t\tnumber of samples in x/y direction",
		"Plot\t\tgenerate the graph using xmgrace",
		"@ioutine shows exact boundary of sampled region",
		"",
		"@b@B4@C7Subsample popup",
		"Stride\t\tsampling period",
		"#X\t\tnew number of pixels in X dir",
		"",
		"@b@B4@C7Auxilliary windows (time, horizontal, vertical)",
		"Rotate\t\t\tturn graph by 90 degrees",
		"Pop\t\t\tpop data window",
		"Save\t\t\twrite the curve data to an output file",
		"Close\t\t\tclose window",
		"Mouse button 1\t\tselect zoom area",
		"Mouse button 3\t\tpop up menu",
		"",	
		"@b@B4@C7Actions in data windows",
		"Mouse 1\t\t\tselect as active and choose cursor point",
		"c\t\t\tshow control window",
		"C\t\t\tclose window",
		"r\t\t\treread file",
		"Alt-q\t\t\texit program",
		"Shift-arrow_key\t\tmove cursor",
		"left/right arrow\tchange time",
		"Up/down arrow\t\tchange depth (2D)",
		"EOF" };

		text->clear();
		int i=0;
		string line;
		while( usagetxt[i] !="EOF" ){
			if( usagetxt[i] != "" )
				line = "@f" + usagetxt[i];
			else
				line = "";
			text->add( line.c_str() );
			i++;
		}
		window->show();
}


void HelpWin :: about()
{
  mode = 2;

  string usagetxt[] = {
	"",
	"@l@b@C1@cFlounder",
	"",
	"@c@C6Version 0.3",
	"@m@cAuthor: Edward Vigmond",
	"@c@C4Copyright 2000 Edward Vigmond",
	"@c@C5Distributed under the terms of the",
	"@c@C5GNU General Public Licence",
	"EOF"
  };
	text->clear();
	int i=0;
	string line;
	while( usagetxt[i] !="EOF" ){
	  if( usagetxt[i] != "" )
		line = "@f" + usagetxt[i];
	  else
		line = "";
	  text->add( line.c_str() );
	  i++;
	}
	window->show();
}


void HelpWin :: image( GLView *w )
{
	mode = 1;
	IGBheader &header = w->model->header;
	char line[2048];
	bool tf;

	text->clear();
    sprintf( line, "@C1@m@c@fFile: %s\n", w->model->fname.c_str() );
    text->add( line );
	text->add( "" );
    sprintf( line, "@fx dimension:\t%d", header.x() );
    text->add( line );
    sprintf( line, "@fy dimension:\t%d", header.y() );
    text->add( line );
    sprintf( line, "@fz dimension:\t%d", header.z() );
    text->add( line );
    sprintf( line, "@ft dimension:\t%d", header.t() );
    text->add( line );
    switch( header.type() ) {
		case IGB_BYTE:
            sprintf( line, "@fdata type:\t%s", "BYTE");
            break;
        case IGB_CHAR:
            sprintf( line, "@fdata type:\t%s", "CHAR");
            break;
        case IGB_SHORT:
            sprintf( line, "@fdata type:\t%s", "SHORT");
            break;
        case IGB_LONG:
            sprintf( line, "@fdata type:\t%s", "LONG");
            break;
        case IGB_FLOAT:
            sprintf( line, "@fdata type:\t%s", "FLOAT");
            break;
        case IGB_DOUBLE:
            sprintf( line, "@fdata type:\t%s", "DOUBLE");
            break;
    }
    text->add( line );
    header.unites(tf);
	if( tf == true ) {
        sprintf( line, "@fPixel units:\t%s", header.unites() );
        text->add( line );
  	}
	if( header.transparent() != NULL ) {
        sprintf( line, "@fTransparent:\t%s", header.transparentstr() );
        text->add( line );
	}
    header.zero(tf);
	if( tf == true ) {
        sprintf( line, "@fPixel zero:\t%g", header.zero() );
        text->add( line );
    }
    header.unites(tf);
	if( tf == true ) {
        sprintf( line, "@fPixel scaling:\t%g", header.facteur() );
        text->add( line );
    }
    header.dim_x(tf);
	if( tf == true ) {
        sprintf( line, "@fX size:\t\t%g", header.dim_x() );
        text->add( line );
    }
    header.unites_x(tf);
	if( tf == true ) {
        sprintf( line, "@fX units:\t%s", header.unites_x() );
        text->add( line );
    }
    header.inc_x(tf);
	if( tf == true ) {
        sprintf( line, "@fIncrement in x:\t%g", header.inc_x() );
        text->add( line );
    }
    header.org_x(tf);
	if( tf == true ) {
        sprintf( line, "@fX origin:\t%g", header.org_x() );
    	text->add( line );
    }
    header.fac_x(tf);
	if( tf == true ) {
        sprintf( line, "@fX scale factor:\t%g", header.fac_x() );
        text->add( line );
    }
    header.dim_y(tf);
	if( tf == true ) {
        sprintf( line, "@fY size:\t\t%g", header.dim_y() );
        text->add( line );
    }
    header.unites_y(tf);
	if( tf == true ) {
        sprintf( line, "@fY units:\t%s", header.unites_y() );
        text->add( line );
    }
    header.inc_y(tf);
	if( tf == true ) {
        sprintf( line, "@fIncrement in y:\t%g", header.inc_y() );
        text->add( line );
    }
    header.org_y(tf);
	if( tf == true ) {
        sprintf( line, "@fY origin:\t%g", header.org_y() );
        text->add( line );
    }
    header.fac_y(tf);
	if( tf == true ) {
  		sprintf( line, "@fY scale factor:\t%g\n", header.fac_y() );
        text->add( line );
    }
    header.dim_z(tf);
	if( tf == true ) {
        sprintf( line, "@fZ size:\t\t%g", header.dim_z() );
        text->add( line );
    }
    header.unites_z(tf);
	if( tf == true ) {
        sprintf( line, "@fZ units:\t%s", header.unites_z() );
        text->add( line );
    }
    header.inc_z(tf);
	if( tf == true ) {
        sprintf( line, "@fIncrement in z:\t%g", header.inc_z() );
        text->add( line );
    }
    header.org_z(tf);
	if( tf == true ) {
        sprintf( line, "@fZ origin:\t%g", header.org_z() );
        text->add( line );
    }
    header.fac_z(tf);
	if( tf == true ) {
        sprintf( line, "@fZ scale factor:\t%g", header.fac_z() );
        text->add( line );
    }
    header.dim_t(tf);
	if( tf == true ) {
        sprintf( line, "@fT size:\t\t%g", header.dim_t() );
        text->add( line );
    }
	header.unites_t(tf);
	if( tf == true ) {
        sprintf( line, "@fT units:\t%s", header.unites_t() );
        text->add( line );
    }
    header.inc_t(tf);
	if( tf == true ) {
        sprintf( line, "@fIncrement in t:\t%g", header.inc_t() );
        text->add( line );
    }
    header.org_t(tf);
	if( tf == true ) {
        sprintf( line, "@fT origin:\t%g", header.org_t() );
        text->add( line );
    }
    header.fac_t(tf);
	if( tf == true ) {
        sprintf( line, "@fT scale factor:\t%g", header.fac_t() );
        text->add( line );
    }
	sprintf( line, "@fCreated on:\t%s\n",header.systemestr());
	text->add( line );
    header.aut_name(tf);
	if( tf == true ) {
        sprintf( line, "@fAuthor:\t%s", header.aut_name() );
        text->add( line );
    }
    /*
	 * header.comment(tf);
	if( tf == true ) {
        sprintf( line, "@fComment:\t%g", header.comment() );
        text->add( line );
    }
	*/

	/*
    sprintf( line, "\nCursor position:\t( " );
    switch( dim_disp ){
        case DISP_XY:
            sprintf( line+strlen(line), "X: %d, Y: %d, Z: %d",
                      w->model->xcursor+1,  w->model->ycursor+1, w->model->depth()+1 );
            break;
        case DISP_XZ:
            sprintf( line+strlen(line), "X: %d, Y: %d, Z: %d", 
                      w->model->xcursor+1, w->model->depth()+1, w->model->ycursor+1 );
            break;
        case DISP_YX:
     		sprintf( line+strlen(line), "X: %d, Y: %d, Z: %d",
                                            ycursor+1, xcursor+1, currDepth+1 );
            break;
        case DISP_YZ:
            sprintf( line+strlen(line), "X: %d, Y: %d, Z: %d", 
                                            currDepth+1, xcursor+1, ycursor+1 );
            break;
        case DISP_ZX:
            sprintf( line+strlen(line), "X: %d, Y: %d, Z: %d",
                                            ycursor+1, currDepth+1, xcursor+1 );
            break;
        case DISP_ZY:
            sprintf( line+strlen(line), "X: %d, Y: %d, Z: %d", 
                                            currDepth+1, ycursor+1, xcursor+1 );
        break;
    }
	sprintf( line+strlen(line), ", T: %d )\n", currTime+1 );
	text->add(line);
	*/
	window->show();
}

void HelpWin::update( GLView *a )
{
	if( window->visible() && mode == 1 ) image( a );
}
