/*
	flounder - copyright 2002 Edward J. Vigmond

	This file is part of flounder.     
	
	flounder is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.     
	
	flounder is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.     
	You should have received a copy of the GNU General Public License
    along with flounder; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <string>
using namespace std;

#define FB_BUFSIZE 1000000

class RenderEPS {
	private:
		GLfloat  viewport[4], clearColor[4];
		float    lineWidth;
		float    pointSize;
		string   fnt;					// Postscript font to use
		float    fntsize;				// size of font
		GLfloat* feedbackBuffer;	
		int      bufsize;				// size of feedback buffer
		FILE*    epsfile;				// output file name
		bool	 fillbgd;				// whether of not to fil background
		GLfloat* spewPrimitiveEPS(FILE * file, GLfloat * loc);
		void spewWireFrameEPS(FILE *, int, GLint, GLfloat *, char *);
		void spewUnsortedFeedback(FILE * file, GLint size, GLfloat * buffer);
		void spewSortedFeedback(FILE * file, GLint size, GLfloat * buffer);
	public:
		RenderEPS( char *, int sz=FB_BUFSIZE );
		~RenderEPS(){free(feedbackBuffer);}
		inline void buffersize(int n){bufsize=n;feedbackBuffer=(GLfloat *)realloc(feedbackBuffer,bufsize*sizeof(float));}
		inline int  buffersize(void){ return bufsize; }
		inline void linewidth( float w ){ lineWidth=w; }
		inline void pointsize( float p ){ pointSize=p; }
		inline void viewprt(GLfloat *vp){memcpy(viewport,vp,4*sizeof(GLfloat));}
		void clearcolor(GLfloat *cc){memcpy(clearColor,cc,4*sizeof(GLfloat));}
		void render( int );
		inline GLfloat* feedbackbuf(){ return feedbackBuffer; }
		inline void fontsize(float a){ fntsize=a; }
		inline void font( char *s ){ fnt=s; }
		inline void fillBackground(bool a){ fillbgd=a; }
};
