/*
	flounder - copyright 2002 Edward J. Vigmond

	This file is part of flounder.     
	
	flounder is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.     
	
	flounder is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.     
	You should have received a copy of the GNU General Public License
    along with flounder; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "../config.h"
#include "flguppy.h"

const int w_valout    = 40;
const int w_sep       = 10;
const int w_samplabel = 20;

void updateval( Fl_Widget *o, void *p )
{
	((Strideslide *)p)->update();
}

Strideslide :: Strideslide( int X, int Y, int W, int H, char *L): 
    Fl_Group(X,Y,W,H,L),
    slider( X, Y, W-w_valout-w_sep-w_samplabel, H ),
    valout(X+W-w_valout-w_samplabel,Y,w_valout, H ),
	samplab(X+W-w_samplabel,Y, w_samplabel, H )
{ 
    end();
    slider.type(FL_HOR_SLIDER);
    slider.minimum(1);
    slider.maximum(20);
    slider.step(1);
    valout.textsize(12);
	quantity = 1;
	slider.value(1);
	slider.callback( updateval, this );
	if( L != 0 ) {
		char* lab = new char[4];
		strcpy( lab, ":# " );
		lab[2] = L[0];
		samplab.label( lab );
		samplab.align( FL_ALIGN_INSIDE|FL_ALIGN_LEFT );
	}
}

void Strideslide :: setnum( int a )
{
	quantity = a;
	valout.value(a);
}

void Strideslide :: update(void)
{
	int stride = int(slider.value());
	valout.value( (quantity+stride-1)/stride );
}

int Strideslide:: value(void)
{
	return int(slider.value());
}

void Strideslide:: color( int c )
{
	slider.color( c );
	valout.color( c );
}

void SubsampleUI:: get_strides(void)
{
	window->show();
	for (;;) {
		Fl::wait();
		Fl_Widget* o = Fl::readqueue();
		if (o == ok_button) {break;}
		else if (o == cancel_button || o == (Fl_Widget *)this) break;
	}
	window->hide();
}

