// generated by Fast Light User Interface Designer (fluid) version 1.0011

#ifndef flguppy_h
#define flguppy_h
#include <FL/Fl.H>
class GlAreaUI;
#include <FL/Fl_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Output.H>

class TableauUI {
public:
  void *widg;
  TableauUI();
  Fl_Window *window;
private:
  inline void cb_window_i(Fl_Window*, void*);
  static void cb_window(Fl_Window*, void*);
public:
  Fl_Value_Slider *x0;
private:
  inline void cb_x0_i(Fl_Value_Slider*, void*);
  static void cb_x0(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *xe;
private:
  inline void cb_xe_i(Fl_Value_Slider*, void*);
  static void cb_xe(Fl_Value_Slider*, void*);
public:
  Fl_Counter *dx;
private:
  inline void cb_dx_i(Fl_Counter*, void*);
  static void cb_dx(Fl_Counter*, void*);
public:
  Fl_Counter *dy;
private:
  inline void cb_dy_i(Fl_Counter*, void*);
  static void cb_dy(Fl_Counter*, void*);
public:
  Fl_Value_Slider *y0;
private:
  inline void cb_y0_i(Fl_Value_Slider*, void*);
  static void cb_y0(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *ye;
private:
  inline void cb_ye_i(Fl_Value_Slider*, void*);
  static void cb_ye(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *t0;
  Fl_Value_Slider *te;
  Fl_Counter *dt;
private:
  inline void cb_Plot_i(Fl_Return_Button*, void*);
  static void cb_Plot(Fl_Return_Button*, void*);
public:
  Fl_Button *closebutton;
private:
  inline void cb_closebutton_i(Fl_Button*, void*);
  static void cb_closebutton(Fl_Button*, void*);
public:
  Fl_Value_Output *numxgraph;
  Fl_Value_Output *numygraph;
  void update();
};
#include <FL/Fl_Double_Window.H>
#include <string>
#include <cstring>
#include "graphwidg.h"
#include <FL/Fl_Light_Button.H>
using namespace std;

class PlotWin {
  double *data;
  int datasize;
  double datamin;
  int tm;        // datum to highlight;
  double *xv;
  double tmx[2], tmy[2];
public:
  Fl_Button *but;
private:
  bool rotated;
  void *glv;
public:
  void set_data( int, double *, int t=-1, double *xd=NULL);
  void highlight( int );
  void rotate( bool );
private:
  void writedata();
public:
  PlotWin(  string title, void *a );
  Fl_Double_Window *window;
private:
  inline void cb_window1_i(Fl_Double_Window*, void*);
  static void cb_window1(Fl_Double_Window*, void*);
public:
  Graph *graph;
  Fl_Group *button_grp;
private:
  inline void cb_Close_i(Fl_Return_Button*, void*);
  static void cb_Close(Fl_Return_Button*, void*);
  inline void cb_Save_i(Fl_Button*, void*);
  static void cb_Save(Fl_Button*, void*);
public:
  Fl_Light_Button *rotbut;
private:
  inline void cb_rotbut_i(Fl_Light_Button*, void*);
  static void cb_rotbut(Fl_Light_Button*, void*);
  inline void cb_Pop_i(Fl_Button*, void*);
  static void cb_Pop(Fl_Button*, void*);
public:
  ~PlotWin();
};
#include "Glarea.h"

class GLView {
public:
  PlotWin *timewin;
  PlotWin *horizon, *vertical;
  GlAreaUI *gui;
  GLView(GlAreaUI *g, char *fn, void *d=NULL);
  Fl_Double_Window *window;
private:
  inline void cb_window2_i(Fl_Double_Window*, void*);
  static void cb_window2(Fl_Double_Window*, void*);
public:
  Glarea *model;
  void arrange_aux_windows();
  ~GLView();
};
#include <FL/Fl_Browser.H>

class HelpWin {
public:
  HelpWin();
  Fl_Window *window;
  Fl_Browser *text;
private:
  inline void cb_Close1_i(Fl_Return_Button*, void*);
  static void cb_Close1(Fl_Return_Button*, void*);
  int mode;
public:
  void usage();
  void image( GLView * );
  void update( GLView * );
  void about();
};
#include "Colourscale.h"
#include <FL/Fl_Menu_Bar.H>
#include "Myslider.h"
#include <FL/Fl_Choice.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Roller.H>
#include <FL/Fl_Dial.H>
#include <FL/Fl_Round_Button.H>

class GlAreaUI {
  void autocolbut( bool );
public:
  ~GlAreaUI();
  GlAreaUI();
  Fl_Window *window;
private:
  inline void cb_window3_i(Fl_Window*, void*);
  static void cb_window3(Fl_Window*, void*);
public:
  Fl_Menu_Bar *mainmenu;
  static Fl_Menu_Item menu_mainmenu[];
  static Fl_Menu_Item *nfme;
private:
  inline void cb_nfme_i(Fl_Menu_*, void*);
  static void cb_nfme(Fl_Menu_*, void*);
  inline void cb_Reread_i(Fl_Menu_*, void*);
  static void cb_Reread(Fl_Menu_*, void*);
  inline void cb_New_i(Fl_Menu_*, void*);
  static void cb_New(Fl_Menu_*, void*);
  inline void cb_Quit_i(Fl_Menu_*, void*);
  static void cb_Quit(Fl_Menu_*, void*);
  inline void cb_Pop1_i(Fl_Menu_*, void*);
  static void cb_Pop1(Fl_Menu_*, void*);
  inline void cb_Iconify_i(Fl_Menu_*, void*);
  static void cb_Iconify(Fl_Menu_*, void*);
  inline void cb_Swap_i(Fl_Menu_*, void*);
  static void cb_Swap(Fl_Menu_*, void*);
  inline void cb_Subsample_i(Fl_Menu_*, void*);
  static void cb_Subsample(Fl_Menu_*, void*);
  inline void cb_EPS_i(Fl_Menu_*, void*);
  static void cb_EPS(Fl_Menu_*, void*);
  inline void cb_PNG_i(Fl_Menu_*, void*);
  static void cb_PNG(Fl_Menu_*, void*);
  inline void cb_GIF_i(Fl_Menu_*, void*);
  static void cb_GIF(Fl_Menu_*, void*);
  inline void cb_GIF1_i(Fl_Menu_*, void*);
  static void cb_GIF1(Fl_Menu_*, void*);
  inline void cb_AVI_i(Fl_Menu_*, void*);
  static void cb_AVI(Fl_Menu_*, void*);
  inline void cb_Colour_i(Fl_Menu_*, void*);
  static void cb_Colour(Fl_Menu_*, void*);
  inline void cb_really_i(Fl_Menu_*, void*);
  static void cb_really(Fl_Menu_*, void*);
public:
  static Fl_Menu_Item *whitebgdbut;
private:
  inline void cb_whitebgdbut_i(Fl_Menu_*, void*);
  static void cb_whitebgdbut(Fl_Menu_*, void*);
public:
  static Fl_Menu_Item *shtmbut;
private:
  inline void cb_shtmbut_i(Fl_Menu_*, void*);
  static void cb_shtmbut(Fl_Menu_*, void*);
public:
  static Fl_Menu_Item *gourshadbut;
private:
  inline void cb_gourshadbut_i(Fl_Menu_*, void*);
  static void cb_gourshadbut(Fl_Menu_*, void*);
public:
  static Fl_Menu_Item *set_animate_delay;
private:
  inline void cb_set_animate_delay_i(Fl_Menu_*, void*);
  static void cb_set_animate_delay(Fl_Menu_*, void*);
  inline void cb_Usage_i(Fl_Menu_*, void*);
  static void cb_Usage(Fl_Menu_*, void*);
  inline void cb_Image_i(Fl_Menu_*, void*);
  static void cb_Image(Fl_Menu_*, void*);
  inline void cb_About_i(Fl_Menu_*, void*);
  static void cb_About(Fl_Menu_*, void*);
public:
  Myslider *tmslider;
private:
  inline void cb_tmslider_i(Myslider*, void*);
  static void cb_tmslider(Myslider*, void*);
public:
  Fl_Choice *imgmenu;
  Fl_Group *animgrp;
private:
  inline void cb__i(Fl_Button*, void*);
  static void cb_(Fl_Button*, void*);
  inline void cb_1_i(Fl_Button*, void*);
  static void cb_1(Fl_Button*, void*);
  inline void cb_2_i(Fl_Button*, void*);
  static void cb_2(Fl_Button*, void*);
public:
  Fl_Choice *animmode;
  static Fl_Menu_Item menu_animmode[];
  Fl_Counter *animinc;
  Fl_Group *fontgrp;
  Fl_Choice *fontchoice;
private:
  inline void cb_fontchoice_i(Fl_Choice*, void*);
  static void cb_fontchoice(Fl_Choice*, void*);
  static Fl_Menu_Item menu_fontchoice[];
public:
  Fl_Value_Input *fontsizein;
private:
  inline void cb_fontsizein_i(Fl_Value_Input*, void*);
  static void cb_fontsizein(Fl_Value_Input*, void*);
public:
  Fl_Choice *colscalech;
  static Fl_Menu_Item menu_colscalech[];
private:
  inline void cb_xpm_i(Fl_Menu_*, void*);
  static void cb_xpm(Fl_Menu_*, void*);
  inline void cb_xpm1_i(Fl_Menu_*, void*);
  static void cb_xpm1(Fl_Menu_*, void*);
  inline void cb_xpm2_i(Fl_Menu_*, void*);
  static void cb_xpm2(Fl_Menu_*, void*);
  inline void cb_xpm3_i(Fl_Menu_*, void*);
  static void cb_xpm3(Fl_Menu_*, void*);
  inline void cb_xpm4_i(Fl_Menu_*, void*);
  static void cb_xpm4(Fl_Menu_*, void*);
public:
  Fl_Light_Button *autobutt;
private:
  inline void cb_autobutt_i(Fl_Light_Button*, void*);
  static void cb_autobutt(Fl_Light_Button*, void*);
public:
  Fl_Button *optimalbut;
private:
  inline void cb_optimalbut_i(Fl_Button*, void*);
  static void cb_optimalbut(Fl_Button*, void*);
public:
  Fl_Value_Input *minval;
private:
  inline void cb_minval_i(Fl_Value_Input*, void*);
  static void cb_minval(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *maxval;
private:
  inline void cb_maxval_i(Fl_Value_Input*, void*);
  static void cb_maxval(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *levels;
private:
  inline void cb_levels_i(Fl_Value_Input*, void*);
  static void cb_levels(Fl_Value_Input*, void*);
public:
  Fl_Tabs *tabs;
private:
  inline void cb_tabs_i(Fl_Tabs*, void*);
  static void cb_tabs(Fl_Tabs*, void*);
public:
  Fl_Group *group2d;
  Fl_Value_Slider *depthslide;
private:
  inline void cb_depthslide_i(Fl_Value_Slider*, void*);
  static void cb_depthslide(Fl_Value_Slider*, void*);
public:
  Fl_Light_Button *horzbut;
private:
  inline void cb_horzbut_i(Fl_Light_Button*, void*);
  static void cb_horzbut(Fl_Light_Button*, void*);
public:
  Fl_Light_Button *vertbut;
private:
  inline void cb_vertbut_i(Fl_Light_Button*, void*);
  static void cb_vertbut(Fl_Light_Button*, void*);
public:
  Fl_Light_Button *tmbut;
private:
  inline void cb_tmbut_i(Fl_Light_Button*, void*);
  static void cb_tmbut(Fl_Light_Button*, void*);
  inline void cb_Arrange_i(Fl_Button*, void*);
  static void cb_Arrange(Fl_Button*, void*);
public:
  Fl_Choice *dimension;
  static Fl_Menu_Item menu_dimension[];
private:
  inline void cb_XY_i(Fl_Menu_*, void*);
  static void cb_XY(Fl_Menu_*, void*);
  inline void cb_YZ_i(Fl_Menu_*, void*);
  static void cb_YZ(Fl_Menu_*, void*);
  inline void cb_ZX_i(Fl_Menu_*, void*);
  static void cb_ZX(Fl_Menu_*, void*);
  inline void cb_YX_i(Fl_Menu_*, void*);
  static void cb_YX(Fl_Menu_*, void*);
public:
  Fl_Check_Button *cbarbut;
private:
  inline void cb_cbarbut_i(Fl_Check_Button*, void*);
  static void cb_cbarbut(Fl_Check_Button*, void*);
public:
  Fl_Group *cursorcol;
  Fl_Light_Button *dispcursbut;
private:
  inline void cb_dispcursbut_i(Fl_Light_Button*, void*);
  static void cb_dispcursbut(Fl_Light_Button*, void*);
public:
  Fl_Check_Button *curslines;
private:
  inline void cb_curslines_i(Fl_Check_Button*, void*);
  static void cb_curslines(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *curscoord;
private:
  inline void cb_curscoord_i(Fl_Check_Button*, void*);
  static void cb_curscoord(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *cursval;
private:
  inline void cb_cursval_i(Fl_Check_Button*, void*);
  static void cb_cursval(Fl_Check_Button*, void*);
public:
  Fl_Button *curscolbut;
private:
  inline void cb_curscolbut_i(Fl_Button*, void*);
  static void cb_curscolbut(Fl_Button*, void*);
public:
  Fl_Button *tableaubut;
private:
  inline void cb_tableaubut_i(Fl_Button*, void*);
  static void cb_tableaubut(Fl_Button*, void*);
public:
  Fl_Light_Button *contourbut;
private:
  inline void cb_contourbut_i(Fl_Light_Button*, void*);
  static void cb_contourbut(Fl_Light_Button*, void*);
public:
  Fl_Value_Slider *numcontslide;
private:
  inline void cb_numcontslide_i(Fl_Value_Slider*, void*);
  static void cb_numcontslide(Fl_Value_Slider*, void*);
public:
  Fl_Value_Input *stvalin;
private:
  inline void cb_stvalin_i(Fl_Value_Input*, void*);
  static void cb_stvalin(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *incvalin;
private:
  inline void cb_incvalin_i(Fl_Value_Input*, void*);
  static void cb_incvalin(Fl_Value_Input*, void*);
public:
  Fl_Check_Button *shdatabut;
private:
  inline void cb_shdatabut_i(Fl_Check_Button*, void*);
  static void cb_shdatabut(Fl_Check_Button*, void*);
public:
  Fl_Group *group3d;
  Fl_Roller *zrotslide;
private:
  inline void cb_zrotslide_i(Fl_Roller*, void*);
  static void cb_zrotslide(Fl_Roller*, void*);
public:
  Fl_Value_Input *xrotin;
private:
  inline void cb_xrotin_i(Fl_Value_Input*, void*);
  static void cb_xrotin(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *yrotin;
private:
  inline void cb_yrotin_i(Fl_Value_Input*, void*);
  static void cb_yrotin(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *zrotin;
private:
  inline void cb_zrotin_i(Fl_Value_Input*, void*);
  static void cb_zrotin(Fl_Value_Input*, void*);
public:
  Fl_Roller *yrotslide;
private:
  inline void cb_yrotslide_i(Fl_Roller*, void*);
  static void cb_yrotslide(Fl_Roller*, void*);
public:
  Fl_Roller *xrotslide;
private:
  inline void cb_xrotslide_i(Fl_Roller*, void*);
  static void cb_xrotslide(Fl_Roller*, void*);
public:
  Fl_Value_Slider *xmslide;
private:
  inline void cb_xmslide_i(Fl_Value_Slider*, void*);
  static void cb_xmslide(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *xpslide;
private:
  inline void cb_xpslide_i(Fl_Value_Slider*, void*);
  static void cb_xpslide(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *ymslide;
private:
  inline void cb_ymslide_i(Fl_Value_Slider*, void*);
  static void cb_ymslide(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *ypslide;
private:
  inline void cb_ypslide_i(Fl_Value_Slider*, void*);
  static void cb_ypslide(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *zmslide;
private:
  inline void cb_zmslide_i(Fl_Value_Slider*, void*);
  static void cb_zmslide(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *zpslide;
private:
  inline void cb_zpslide_i(Fl_Value_Slider*, void*);
  static void cb_zpslide(Fl_Value_Slider*, void*);
public:
  Fl_Check_Button *dispaxesbut;
private:
  inline void cb_dispaxesbut_i(Fl_Check_Button*, void*);
  static void cb_dispaxesbut(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *dispframebut;
private:
  inline void cb_dispframebut_i(Fl_Check_Button*, void*);
  static void cb_dispframebut(Fl_Check_Button*, void*);
public:
  Fl_Button *frcolourbut;
private:
  inline void cb_frcolourbut_i(Fl_Button*, void*);
  static void cb_frcolourbut(Fl_Button*, void*);
public:
  Fl_Roller *zscaleslide;
private:
  inline void cb_zscaleslide_i(Fl_Roller*, void*);
  static void cb_zscaleslide(Fl_Roller*, void*);
public:
  Fl_Value_Output *zscaleout;
  Fl_Light_Button *isobut0;
private:
  inline void cb_isobut0_i(Fl_Light_Button*, void*);
  static void cb_isobut0(Fl_Light_Button*, void*);
public:
  Fl_Value_Input *isovalin1;
private:
  inline void cb_isovalin1_i(Fl_Value_Input*, void*);
  static void cb_isovalin1(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *r1;
private:
  inline void cb_r1_i(Fl_Value_Input*, void*);
  static void cb_r1(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *g1;
private:
  inline void cb_g1_i(Fl_Value_Input*, void*);
  static void cb_g1(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *b1;
private:
  inline void cb_b1_i(Fl_Value_Input*, void*);
  static void cb_b1(Fl_Value_Input*, void*);
public:
  Fl_Dial *alpha1;
private:
  inline void cb_alpha1_i(Fl_Dial*, void*);
  static void cb_alpha1(Fl_Dial*, void*);
public:
  Fl_Button *colchoos1;
private:
  inline void cb_colchoos1_i(Fl_Button*, void*);
  static void cb_colchoos1(Fl_Button*, void*);
public:
  Fl_Value_Input *isovalin0;
private:
  inline void cb_isovalin0_i(Fl_Value_Input*, void*);
  static void cb_isovalin0(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *r0;
private:
  inline void cb_r0_i(Fl_Value_Input*, void*);
  static void cb_r0(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *g0;
private:
  inline void cb_g0_i(Fl_Value_Input*, void*);
  static void cb_g0(Fl_Value_Input*, void*);
public:
  Fl_Value_Input *b0;
private:
  inline void cb_b0_i(Fl_Value_Input*, void*);
  static void cb_b0(Fl_Value_Input*, void*);
public:
  Fl_Dial *alpha0;
private:
  inline void cb_alpha0_i(Fl_Dial*, void*);
  static void cb_alpha0(Fl_Dial*, void*);
public:
  Fl_Button *colchoos0;
private:
  inline void cb_colchoos0_i(Fl_Button*, void*);
  static void cb_colchoos0(Fl_Button*, void*);
public:
  Fl_Light_Button *isobut1;
private:
  inline void cb_isobut1_i(Fl_Light_Button*, void*);
  static void cb_isobut1(Fl_Light_Button*, void*);
public:
  Fl_Value_Input *transminval;
private:
  inline void cb_transminval_i(Fl_Value_Input*, void*);
  static void cb_transminval(Fl_Value_Input*, void*);
public:
  Fl_Light_Button *solobjbut;
private:
  inline void cb_solobjbut_i(Fl_Light_Button*, void*);
  static void cb_solobjbut(Fl_Light_Button*, void*);
public:
  Fl_Value_Input *transmaxval;
private:
  inline void cb_transmaxval_i(Fl_Value_Input*, void*);
  static void cb_transmaxval(Fl_Value_Input*, void*);
public:
  Fl_Check_Button *transrangebut;
private:
  inline void cb_transrangebut_i(Fl_Check_Button*, void*);
  static void cb_transrangebut(Fl_Check_Button*, void*);
public:
  Fl_Round_Button *quickbut;
private:
  inline void cb_quickbut_i(Fl_Round_Button*, void*);
  static void cb_quickbut(Fl_Round_Button*, void*);
public:
  Fl_Check_Button *rngcompbut;
private:
  inline void cb_rngcompbut_i(Fl_Check_Button*, void*);
  static void cb_rngcompbut(Fl_Check_Button*, void*);
public:
  Fl_Light_Button *lightbut;
private:
  inline void cb_lightbut_i(Fl_Light_Button*, void*);
  static void cb_lightbut(Fl_Light_Button*, void*);
public:
  Fl_Value_Slider *xlghtpos;
private:
  inline void cb_xlghtpos_i(Fl_Value_Slider*, void*);
  static void cb_xlghtpos(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *ylghtpos;
private:
  inline void cb_ylghtpos_i(Fl_Value_Slider*, void*);
  static void cb_ylghtpos(Fl_Value_Slider*, void*);
public:
  Fl_Value_Slider *zlghtpos;
private:
  inline void cb_zlghtpos_i(Fl_Value_Slider*, void*);
  static void cb_zlghtpos(Fl_Value_Slider*, void*);
  HelpWin *help;
public:
  TableauUI *tabwin;
private:
  GLView *curr_glwin;
  int time;
public:
  int get_time();
private:
  vector<GLView *> glwin;
  void animate( int );
public:
  void add_glwin( char * );
  void destroy_glwin( GLView * );
private:
  void update_glwins();
  int animDir;
  float animate_delay;
public:
  void set_animation_delay();
private:
  friend void animate_cb( void * );
public:
  void setcurrent( GLView *a, bool b=false );
private:
  void setcurrentcb( Fl_Widget *, void * );
  void timebutcb( bool );
  void horzbutcb( bool );
  void vertbutcb( bool );
public:
  void tmstep( int );
private:
  void copy_glwin();
  void setimagemenu();
public:
  void set_tm_max();
private:
  void movie( bool single = false );
  void setfont();
  void change_isocolour( int, Fl_Value_Input *, Fl_Value_Input *, Fl_Value_Input*, double);
  void set_contour();
  void output_eps();
  void output_png();
public:
  void avi_movie( void );
};

class SubsampleUI {
public:
  SubsampleUI();
  Fl_Window *window;
  Fl_Return_Button *ok_button;
  Fl_Button *cancel_button;
  Strideslide *xstrslide;
  Strideslide *ystrslide;
  Strideslide *zstrslide;
  void get_strides( void );
};
#endif
