/*
	flounder - copyright 2002 Edward J. Vigmond

	This file is part of flounder.     
	
	flounder is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.     
	
	flounder is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.     
	You should have received a copy of the GNU General Public License
    along with flounder; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "../config.h"
#include "flguppy.h"
#include <FL/math.h>
#include <signal.h>

GlAreaUI *congui;

void sighandler( int sig )
{
	switch( sig ){
		case 1:
			congui->tmstep(1);
			break;
	}
}


void setcurrent_cb( Fl_Widget *o, void *v )
{
	congui->setcurrent((GLView *)v);
}

int main(int argc, char **argv) {

  	Fl::gl_visual(FL_RGB|FL_DOUBLE|FL_ALPHA|FL_DEPTH);
  	GlAreaUI controls;
 	controls.window->show();
	if( argc>1 )
		for( int i=0; i<argc-1; i++ )
  			controls.add_glwin( argv[i+1] );
		else
  			controls.add_glwin( "" );
  	congui = &controls;
	signal( 1, sighandler );
    return Fl::run();
}

